﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Infragistics.Web.UI;
using Infragistics.Web.UI.GridControls;
using System.Data;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Init(object sender, EventArgs e)
    {
        myTemplate temp = new myTemplate();
        ItemTemplate template = new ItemTemplate();

        template.Template = temp;
        template.TemplateID = "template1";

        WebDataGrid1.Templates.Add(template);
    }

    protected void Page_Load(object sender, EventArgs e)
    {
        WebDataGrid1.DataSource = populateGrid();
        WebDataGrid1.DataBind();
    }

    protected void WebDataGrid1_InitializeRow(object sender, Infragistics.Web.UI.GridControls.RowEventArgs e)
    {
        e.Row.Items[0].TemplateId = "template1";
    }

    protected DataTable populateGrid()
    {
        DataTable dt = new DataTable();
        dt.Columns.Add("Name");
        DataRow row;
        for (int i = 0; i < 10; i++)
        {
            row = dt.NewRow();
            row.SetField<string>("Name", "Name" + i);
            dt.Rows.Add(row);
        }

        return dt;
    }

    protected void WebDataGrid1_Init(object sender, EventArgs e)
    {
        //myTemplate temp = new myTemplate();
        //ItemTemplate template = new ItemTemplate();

        //template.Template = temp;
        //template.TemplateID = "template1";

        //WebDataGrid1.Templates.Add(template);
        
    }
}

class myTemplate : ITemplate
{
    public void InstantiateIn(Control container)
    {
        Button button = new Button();
        button.OnClientClick = "return Button1_Click()"; 
        container.Controls.Add(button);

    }
}